﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace Buttons
{
    public partial class Form1 : RadForm
    {
        public Form1()
        {
            InitializeComponent();

            CustomCalculator calculator = new CustomCalculator();
            calculator.Size = new Size(300, 300);
            RadCalculatorContentElement calculatorContentElement = calculator.RootElement.Children[0].Children[1] as RadCalculatorContentElement;
            calculatorContentElement.DrawBorder = false;
            this.Controls.Add(calculator);
        }
    }

    public class CustomCalculator : RadControl
    {
        protected override void CreateChildItems(RadElement parent)
        {
            base.CreateChildItems(parent);
            CustomCalculatorElement element = new CustomCalculatorElement();
            parent.Children.Add(element);
        }
    }

    public class CustomCalculatorElement : LightVisualElement
    {
        private RadCalculatorDropDownElement calculatorElement;
        private RadCalculatorContentElement contentElement;

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            calculatorElement = new RadCalculatorDropDownElement();
            this.Children.Add(calculatorElement);
            calculatorElement.ArrowButton.Visibility = ElementVisibility.Collapsed;
            calculatorElement.MinSize = new System.Drawing.Size(0, 30);

            contentElement = calculatorElement.CalculatorContentElement;
            this.Children.Add(calculatorElement.CalculatorContentElement);
        }

        protected override SizeF MeasureOverride(SizeF availableSize)
        {
            SizeF res = base.MeasureOverride(availableSize);
            this.contentElement.Measure(new SizeF(availableSize.Width, availableSize.Height - calculatorElement.DesiredSize.Height));
            return res;
        }

        protected override SizeF ArrangeOverride(SizeF finalSize)
        {
            base.ArrangeOverride(finalSize);
            this.calculatorElement.Arrange(new RectangleF(0,0,finalSize.Width, calculatorElement.DesiredSize.Height));
            this.contentElement.Arrange(new RectangleF(0,calculatorElement.DesiredSize.Height,finalSize.Width, finalSize.Height - calculatorElement.DesiredSize.Height));

            return finalSize;
        }
    }
}
